function load()
{
	setupParts();
	checkPassword("");
	
	if(passwordIsValid == false)
        setTimeout('showBack(null);', 0);
}

function remove()
{
	// your widget has just been removed from the layer
	// remove any preferences as needed
	// widget.setPreferenceForKey(null, "your-key");
}

function hide()
{
	// your widget has just been hidden stop any timers to
	// prevent cpu usage
}

function show()
{
	// your widget has just been shown.  restart any timers
	// and adjust your interface as needed
}

function showBack(event)
{
	// your widget needs to show the back

	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToBack");

	front.style.display="none";
	back.style.display="block";
	
	if (window.widget)
		setTimeout('widget.performTransition();', 0);
}

function showFront(event)
{
	// your widget needs to show the front

	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToFront");

	front.style.display="block";
	back.style.display="none";
	
	if (window.widget)
		setTimeout('widget.performTransition();', 0);
}

/*
 getLocalizedString() pulls a string out an array named localizedStrings.  Each language project directory in this widget contains a file named "localizedStrings.js", which, in turn, contains an array called localizedStrings.  This method queries the array of the file of whichever language has highest precedence, according to the International pane of System Preferences.
*/
function getLocalizedString(string)
{
	try { string = localizedStrings[string] || string; } catch (e) {}
	return string;
}

if (window.widget)
{
	widget.onremove = remove;
	widget.onhide = hide;
	widget.onshow = show;
}

/* the real meat of the widget */

function swap()
{
    document.getElementById("realContent").innerHTML = nextString;
    document.getElementById("text4").innerHTML = resultsCount;
    
    myScrollArea.refresh();
}

var nextString;

function doSearch(query)
{
    if (WalletPlugin) {
        nextString = WalletPlugin.getWalletEntriesFromString(query);
        resultsCount = WalletPlugin.getResultsCount();

        hideContent();						
        setTimeout("swap();",500);			
        setTimeout("showContent();",550);	
    }else{
        alert("Widget plugin not loaded.");
    }
    
    
    myScrollArea.refresh();
}

var passwordIsValid;

function checkPassword(password)
{
    if (WalletPlugin) {
        passwordIsValid = WalletPlugin.checkPassword(password);
        passwordIsValid = WalletPlugin.checkPassword(password);
    }
    
    if(password == ''){
        if(passwordIsValid == true){
            document.getElementById("realContent").innerHTML = "";
            myScrollArea.refresh();

            document.getElementById("passindicator").style.background = "url(Images/IndicatorOn.png)";
            document.getElementById("searchfield").disabled = false;
            document.getElementById("textfield").disabled = true;        
        }else{
            document.getElementById("passindicator").style.background = "url(Images/IndicatorOff.png)";
        }
    }else if(passwordIsValid == true){
        document.getElementById("realContent").innerHTML = "";
        myScrollArea.refresh();

        document.getElementById("passindicator").style.background = "url(Images/IndicatorOn.png)";
        document.getElementById("searchfield").disabled = false;
        document.getElementById("textfield").disabled = true;
    }else{
        document.getElementById("passindicator").style.background = "url(Images/IndicatorCritical.png)";
    }

}

/**************************/
// Animation code
// Handles the fades in and out
/**************************/

var animation = {duration:0, starttime:0, to:1.0, now:1.0, from:0.0, firstElement:null, timer:null};

function showContent()
{

		if (animation.timer != null)			// reset the animation timer value, in case a value was left behind
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; 		// set it back one frame
		
		animation.duration = 500;												// animation time, in ms
		animation.starttime = starttime;										// specify the start time
		animation.firstElement = document.getElementById ('realContent');				// specify the element to fade
		animation.timer = setInterval ("animate();", 13);						// set the animation function
		animation.from = animation.now;											// beginning opacity (not ness. 0)
		animation.to = 1.0;														// final opacity
		animate();																// begin animation

}


function hideContent()
{

		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13;
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('realContent');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();

}


function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
		
	
	T = limit_3(time-animation.starttime, 0, animation.duration);
	
	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	
	animation.firstElement.style.opacity = animation.now;
}


// these functions are utilities used by animate()

function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

function copyToClipboard (element)
{
    // Set the clipboard
    widget.system("/bin/echo '" + element + "' | /usr/bin/pbcopy", null);

    // Close Dashboard
    widget.openURL("");
}

function resetWidget(){
    document.getElementById("realContent").innerHTML = "<b>enter password to search</b><br /> (flip widget)";
    document.getElementById("text4").innerHTML = "0 results";
    myScrollArea.refresh();

    document.getElementById("searchfield").disabled = true;
    document.getElementById("searchfield").value = "";
    document.getElementById("textfield").disabled = false; 
    document.getElementById("textfield").value = "";       
    document.getElementById("passindicator").style.background = "url(Images/IndicatorOff.png)";

}
